diff -Naur --exclude=CVS --exclude=configs linux/hpc/rinode.c linux-openmosix/hpc/rinode.c
--- linux/hpc/rinode.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/hpc/rinode.c	2003-06-14 07:18:11.000000000 +0200
@@ -0,0 +1,622 @@
+/* Changes since Feb 12, 2002 by Moshe Bar
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ *
+ *  Author(s): Amnon Shiloh, Moshe Bar
+ */
+#include <linux/sched.h>
+#include <hpc/protocol.h>
+#include <hpc/comm.h>
+#include <linux/hpc.h>
+#include <linux/smp_lock.h>
+#include <linux/file.h>
+#include <linux/dcache.h>
+#include <linux/slab.h>
+#include <hpc/routines.h>
+#include <hpc/debug.h>
+
+/* REMOTE section: */
+
+spinlock_t rinode_list_lock = SPIN_LOCK_UNLOCKED;
+
+
+#define	next_entry(dp)	((struct dentry *)(dp)->d_fsdata)
+
+static struct dentry *rinode_list = NULL;
+
+static int remote_dentry_delete(struct dentry *);
+static void remote_dentry_iput(struct dentry *, struct inode *);
+static int mosix_remote_file_mmap(struct file *, struct vm_area_struct *);
+
+extern struct super_block bad_super_block;
+
+static struct dentry_operations remote_dentry_ops =
+{
+	.d_delete = remote_dentry_delete,
+	.d_iput = remote_dentry_iput
+};
+
+static struct file_operations remote_file_operations =
+{
+	.mmap = mosix_remote_file_mmap,
+};
+
+struct address_space_operations remote_aops =
+{
+	.readpage = remote_readpage,
+};
+
+void
+invalidate_old_remote_pages(struct inode *ip)
+{
+	down(&ip->i_sem);
+	/* we prefer "invalidate_inode_pages",
+	   but it does not work on locked pages */
+	truncate_inode_pages(ip->i_mapping, 0);
+	up(&ip->i_sem);
+}
+
+struct file *
+get_remote_file(int origin, struct file *fpr, struct dentry *dpr, uint64_t uniq, off_t isize,
+								nopage_t nopage)
+{
+	register struct file *f;
+	register struct dentry *d, *d2;
+	register struct inode *ip, *i2;
+	struct vm_area_struct *vma;
+	int cng;
+	struct dentry *to_dput = NULL;
+	struct inode *to_iput = NULL;
+
+	for(vma = current->mm->mmap ; vma ; vma = vma->vm_next)
+	if((f = vma->vm_file) && home_file(f) == fpr)
+	{
+		ip = f->f_dentry->d_inode;
+		if(ip->u.remote_i.origin == origin && ip->u.remote_i.dp == dpr
+			&& ip->u.remote_i.unique == uniq && ip->i_size == isize
+			&& ip->u.remote_i.nopage == nopage)
+		{
+			get_file(f);
+			return(f);
+		}
+	}
+	if(!(f = get_empty_filp()))
+		return(NULL);
+	spin_lock(&dcache_lock);
+	spin_lock(&rinode_list_lock);
+	for(d = rinode_list ; d ; d = next_entry(d))
+	{
+		ip = d->d_inode;
+		if(ip->u.remote_i.origin == origin && ip->u.remote_i.dp == dpr)
+		{
+			join_in:
+			cng = (ip->u.remote_i.unique != uniq) ||
+				(ip->u.remote_i.nopage != nopage) ||
+				(isize < ip->i_size);
+			ip->i_size = isize;
+			if(cng)
+			{
+				ip->u.remote_i.unique = uniq;
+				ip->u.remote_i.nopage = nopage;
+			}
+			dget(d);
+			spin_unlock(&rinode_list_lock);
+			spin_unlock(&dcache_lock);
+			if(to_iput)
+				iput(to_iput);
+			if(to_dput)
+				dput(to_dput);
+			if(cng)
+				invalidate_old_remote_pages(ip);
+			f->f_dentry = d;
+			f->f_op = &remote_file_operations;
+			f->f_mode = FMODE_READ;
+			home_file(f) = fpr;
+			return(f);
+		}
+	}
+	spin_unlock(&rinode_list_lock);
+	spin_unlock(&dcache_lock);
+	if(!(ip = new_inode(&bad_super_block)))
+	{
+		put_filp(f);
+		return(NULL);
+	}
+	ip->i_mode = S_IFREG;
+	ip->u.remote_i.origin = origin;
+	ip->u.remote_i.dp = dpr;
+	ip->u.remote_i.unique = uniq;
+	ip->u.remote_i.nopage = nopage;
+	ip->i_size = isize;
+	ip->i_fop = &remote_file_operations;
+	ip->i_mapping->a_ops = &remote_aops;
+	if(!(d = d_alloc(NULL, &(const struct qstr) { "/", 1, 0 })))
+	{
+		put_filp(f);
+		iput(ip);
+		return(NULL);
+	}
+	d->d_parent = d;
+	/* any copy created while we slept? */
+	spin_lock(&dcache_lock);
+	spin_lock(&rinode_list_lock);
+	for(d2 = rinode_list ; d2 ; d2 = next_entry(d2))
+	{
+		i2 = d2->d_inode;
+		if(i2->u.remote_i.origin == origin && i2->u.remote_i.dp == dpr)
+		{
+			to_iput = ip;
+			to_dput = d;
+			d = d2;
+			ip = i2;
+			goto join_in;
+		}
+	}
+	d->d_op = &remote_dentry_ops;
+	d->d_inode = ip;
+	next_entry(d) = rinode_list;
+	rinode_list = d;
+	f->f_dentry = d;
+	f->f_op = &remote_file_operations;
+	f->f_mode = 1;
+	home_file(f) = fpr;
+	spin_unlock(&rinode_list_lock);
+	spin_unlock(&dcache_lock);
+	return(f);
+}
+
+/*
+ * called by fput(fd) ==> dput(d)
+ */
+
+static int
+remote_dentry_delete(struct dentry *del)
+{
+	register struct dentry *dp;
+
+	spin_lock(&rinode_list_lock);
+	if(del == rinode_list)
+		rinode_list = next_entry(del);
+	else
+	{
+		for(dp = rinode_list ; dp && next_entry(dp) != del ;
+							dp = next_entry(dp))
+		if(!dp)
+			panic("remote dentry not listed");
+		next_entry(dp) = next_entry(del);
+	}
+	spin_unlock(&rinode_list_lock);
+	return(1);
+}
+
+static void
+remote_dentry_iput(struct dentry *dp, struct inode *ip)
+{
+	invalidate_old_remote_pages(ip);
+	iput(ip);
+}
+
+struct vm_operations_struct rinode_mmap =
+{
+	.nopage = filemap_nopage,
+};
+
+static int
+mosix_remote_file_mmap(struct file *file, struct vm_area_struct *vma)
+{
+	if (vma->vm_flags & VM_SHARED)
+		panic("REMOTE VM_SHARED mmap");
+	vma->vm_ops = &rinode_mmap;
+	return(0);
+}
+
+int
+remote_report_files(void)
+{
+	register struct vm_area_struct *vma, *vmb;
+	struct mm_struct *mm = current->mm;
+	struct file **fp = NULL;
+	int n = 0;
+	int result;
+
+	down_read(&mm->mmap_sem);
+	for(vma = mm->mmap ; vma ; vma = vma->vm_next)
+	if(vma->vm_file)
+	{
+		for(vmb = mm->mmap ; vmb != vma ; vmb = vmb->vm_next)
+		if(vmb->vm_file == vma->vm_file)
+			break;
+		if(vmb == vma)
+			n++;
+	}
+	up_read(&mm->mmap_sem);
+	if(n && !(fp = kmalloc(n * sizeof(struct file *), GFP_KERNEL)))
+		n = -EAGAIN;
+	else
+	{
+		down_read(&mm->mmap_sem);
+		for(n = 0 , vma = mm->mmap ; vma ; vma = vma->vm_next)
+		if(vma->vm_file)
+		{
+			for(vmb = mm->mmap ; vmb != vma ; vmb = vmb->vm_next)
+			if(vmb->vm_file == vma->vm_file)
+				break;
+			if(vmb == vma)
+				fp[n++] = home_file(vma->vm_file);
+		}
+		up_read(&mm->mmap_sem);
+	}
+	result = comm_send(DEP_LISTHOLD|REPLY, &n, sizeof(int),
+		fp, n > 0 ? n * sizeof(struct file *) : 0, 0);
+	if(n > 0)
+		kfree(fp);
+	return(result);
+}
+
+void
+rinode_flush_files(int pe)
+{
+	register struct dentry *dp;
+	register struct inode *ip;
+
+
+	loop:
+	spin_lock(&rinode_list_lock);
+	for(dp = rinode_list ; dp ; dp = next_entry(dp))
+	{
+		ip = dp->d_inode;
+		if(ip->u.remote_i.origin == pe && ip->u.remote_i.nopage)
+		{
+			ip->u.remote_i.dp = NULL;
+			/* (the pointer is no good and any process
+			 * still using this inode is doomed anyway) */
+			ip->u.remote_i.unique = 0xffffffffffffffffULL;
+			ip->u.remote_i.nopage = NULL;
+			spin_unlock(&rinode_list_lock);
+			invalidate_old_remote_pages(ip);
+			goto loop;
+		}
+	}
+	spin_unlock(&rinode_list_lock);
+}
+
+/* DEPUTY section: */
+
+#define DEFAULT_ALLOCATION	10
+
+#define	ALLOCATED_NEW		1
+#define	ALLOCATED_NEW_AND_DENY	2
+#define	ADDED_A_DENY		3
+#define	FOUND_OLD		4
+
+int
+mosix_register_a_file(struct file *fp, int denywrite)
+{
+	struct task_struct *p = current;
+	register int i, new;
+	struct held_files *nh, *oh;
+	struct mm_struct *mm;
+
+	if(!p->mosix.held_allocated)
+	{
+		if((mm = p->mm) && atomic_read(&mm->mm_realusers) > 1)
+			return(0);
+		nh = NULL;	/* COMPILER BUG -- hope it is optimized out */
+		for(i = DEFAULT_ALLOCATION ; i > 0 ; i >>= 1)
+		if((nh = (struct held_files *)
+			kmalloc(i * sizeof(struct held_files), GFP_KERNEL)))
+			break;
+		if(!nh)
+			return(-ENOMEM);
+		memset(nh, 0, i * sizeof(struct held_files));
+		task_lock(p);
+		p->mosix.held_files = nh;
+		p->mosix.held_allocated = i;
+		task_unlock(p);
+		new = 0;
+	}
+	else
+	{
+		new = -1;
+		for(i = 0 ; i < p->mosix.held_allocated ; i++)
+		if((struct file *)p->mosix.held_files[i].f == fp)
+		{
+			if(!denywrite || p->mosix.held_files[i].denywrite)
+				return(FOUND_OLD);
+			if(deny_write_access(fp))
+				return(-ETXTBSY);
+			p->mosix.held_files[i].denywrite = 1;
+			return(ADDED_A_DENY);
+		}
+		else if(new == -1 && !p->mosix.held_files[i].f)
+			new = i;
+		if(new == -1)
+		{
+			nh = NULL;/* COMPILER BUG -- hope it is optimized out */
+			for(i = DEFAULT_ALLOCATION ; i > 0 ; i >>= 1)
+			if((nh = kmalloc((i + p->mosix.held_allocated) *
+				sizeof(struct held_files), GFP_KERNEL)))
+				break;
+			if(!i)
+				return(-ENOMEM);
+			for(new = p->mosix.held_allocated + i - 1 ;
+				new >= p->mosix.held_allocated ; new--)
+				nh[new].f = NULL;
+			for(new = 0 ; new < p->mosix.held_allocated ; new++)
+				nh[new] = p->mosix.held_files[new];
+			oh = p->mosix.held_files;
+			task_lock(p);
+			p->mosix.held_files = nh;
+			p->mosix.held_allocated += i;
+			task_unlock(p);
+			kfree(oh);
+		}
+	}
+	get_file(fp);
+	task_lock(p);
+	p->mosix.held_files[new].f = fp;
+	task_unlock(p);
+	if((p->mosix.held_files[new].denywrite = denywrite))
+	{
+		if(deny_write_access(fp))
+		{
+			task_lock(p);
+			p->mosix.held_files[new].f = NULL;
+			task_unlock(p);
+			return(-ETXTBSY);
+		}
+		return(ALLOCATED_NEW_AND_DENY);
+	}
+	else
+		return(ALLOCATED_NEW);
+}
+
+void
+mosix_undo_last_file_registration(struct file *fp, int result)
+{
+	register unsigned int i;
+	struct mosix_task *m = &current->mosix;
+
+	if(result == FOUND_OLD)
+		return;
+	for(i = 0 ; i < m->held_allocated ; i++)
+	if((struct file *)m->held_files[i].f == fp)
+	{
+		switch(result)
+		{
+		case ADDED_A_DENY:
+		case ALLOCATED_NEW_AND_DENY:
+			if(!m->held_files[i].denywrite)
+				printk("%s: mosix_undo_last_file_registration - no denywrite\n",
+				       desc_mostask(m));
+			else
+				allow_write_access(fp);
+			if(result == ADDED_A_DENY)
+				break;
+		case ALLOCATED_NEW:
+			fput(fp);
+			task_lock(current);
+			m->held_files[i].f = NULL;
+			task_unlock(current);
+			break;
+		}
+		return;
+	}
+	printk("%s: mosix_undo_last_file_registration - not found\n",
+		desc_mostask(m));
+}
+
+void
+mosix_update_remote_files(void)
+{
+	struct task_struct *p = current;
+	register struct held_files *h = p->mosix.held_files;
+	register unsigned int i, j;
+	int op, np;
+	struct file **rf;
+	struct file *fp;
+
+	if(!(op = p->mosix.held_allocated))
+		return;
+	if(deputy_request(DEP_LISTHOLD, NULL, 0, NULL, 0, 0,
+						(void **)&np, -sizeof(int)))
+		deputy_die_on_communication();
+	if(np < 0 || (np && comm_recvdata((void **)&rf) < 0))
+		deputy_die_on_communication();
+	for(j = 0 ; j < op ; j++)
+		h[j].denywrite = (h[j].denywrite != 0) | 2;
+	for(i = 0 ; i < np ; i++)
+	{
+		for(j = 0 ; j < op ; j++)
+		if(h[j].f == rf[i])
+		{
+			h[j].denywrite &= ~2;
+			break;
+		}
+		if(j == op)
+			panic("mosix_update_remote_files: not listed");
+	}
+	for(j = 0 ; j < op ; j++)
+	if((fp = h[j].f) && (h[j].denywrite & 2))
+	{
+		task_lock(p);
+		h[j].f = NULL;
+		task_unlock(p);
+		if(h[j].denywrite & 1)
+			allow_write_access(fp);
+		fput(fp);
+	}
+	if(np)
+		comm_free(rf);
+}
+
+int
+mosix_rebuild_file_list(void)
+{
+	struct task_struct *p = current;
+	register struct vm_area_struct *vma, *vmb;
+	struct mm_struct *mm = p->mm;
+	struct held_files *hf = NULL, *old;
+	unsigned int i, n;
+	int oldn;
+	unsigned int denywrite;
+	struct file *this;
+
+	if(p->mosix.dflags & DDEPUTY)
+	{
+		if(p->mosix.dflags & DINCOMING)
+			p->mosix.dflags |= DDELAYHELD;
+		else
+			mosix_update_remote_files();
+		return(0);
+	}
+	if(atomic_read(&mm->mm_realusers) > 1)
+	{
+		mosix_clear_all_held_files(p);	/* discard old */
+		return(-EBUSY);	/* thread */
+	}
+	/* because we are the only clone, no MM lock is needed */
+	/* and the initial count cannot change */
+
+	for(n = 0 , vma = mm->mmap ; vma ; vma = vma->vm_next)
+	if((this = vma->vm_file))
+	{
+		for(vmb = mm->mmap ; vmb != vma ; vmb = vmb->vm_next)
+		if(vmb->vm_file == vma->vm_file)
+			break;
+		if(vmb == vma)
+		{
+			if(this->f_dentry->d_inode->i_mapping->i_mmap_shared)
+			{
+				monkey:
+				mosix_clear_all_held_files(p);
+				tell_process(p, DREQ_CHECKSTAY);
+				return(-EDIST);
+			}
+			n++;
+		}
+	}
+	if(n && !(hf = kmalloc(n*sizeof(struct held_files), GFP_KERNEL)))
+	{
+		mosix_clear_all_held_files(p);	/* discard old */
+		return(-ENOMEM);
+	}
+	for(n = 0 , vma = mm->mmap ; vma ; vma = vma->vm_next)
+	if((this = vma->vm_file))
+	{
+		for(vmb = mm->mmap ; vmb != vma ; vmb = vmb->vm_next)
+		if(vmb->vm_file == this)
+			goto already_placed;
+		denywrite = 0;
+		for(; vmb ; vmb = vmb->vm_next)
+		if(vmb->vm_file == this && (vmb->vm_flags & VM_DENYWRITE))
+		{
+			denywrite = 1;
+			atomic_dec(&this->f_dentry->d_inode->i_writecount);
+			break;
+		}
+		get_file(this);
+		hf[n].f = this;
+		hf[n++].denywrite = denywrite;
+		already_placed:;
+	}
+	/* must not use "mosix_clear_all_held_files" because it could sleep */
+	/* in 'fput' when another held file becomes VMONKEY */
+	oldn = p->mosix.held_allocated;
+	old = p->mosix.held_files;
+	task_lock(p);
+	p->mosix.held_files = hf;
+	p->mosix.held_allocated = n;
+	task_unlock(p);
+	if(old)
+	{
+		for(i = 0 ; i < oldn ; i++)
+		if((this = old[i].f))
+		{
+			if(old[i].denywrite)
+				allow_write_access(this);
+			fput(this);
+		}
+		kfree(old);
+	}
+	/* final race check: has any file been made monkey meanwhile? */
+	for(i = 0 ; i < n ; i++)
+	if(hf[i].f->f_dentry->d_inode->i_mapping->i_mmap_shared)
+		goto monkey;
+	return(0);
+}
+
+int
+fork_mosix_remote_files(struct task_struct *p)
+{
+	register unsigned int i;
+	register struct file *fp;
+
+	if(!(p->mosix.held_allocated = current->mosix.held_allocated))
+		return(0);
+	if(!(p->mosix.held_files = kmalloc(p->mosix.held_allocated *
+		sizeof(struct held_files), GFP_KERNEL)))
+	{
+		p->mosix.held_allocated = 0;
+		return(-ENOMEM);
+	}
+	for(i = 0 ; i < current->mosix.held_allocated ; i++)
+	if((fp = (struct file *)current->mosix.held_files[i].f))
+	{
+		get_file(fp);
+		p->mosix.held_files[i].f = fp;
+		if((p->mosix.held_files[i].denywrite =
+			current->mosix.held_files[i].denywrite))
+			atomic_dec(&fp->f_dentry->d_inode->i_writecount);
+	}
+	else
+		p->mosix.held_files[i].f = NULL;
+	return(0);
+}
+
+void
+mosix_clear_all_held_files(struct task_struct *p)
+{
+	register unsigned int i;
+	register int n;
+	struct held_files *h;
+
+	if(!(n = p->mosix.held_allocated))
+		return;
+	h = p->mosix.held_files;
+	task_lock(p);
+	p->mosix.held_files = NULL;
+	p->mosix.held_allocated = 0;
+	task_unlock(p);
+	for(i = 0 ; i < n ; i++)
+	if(h[i].f)
+	{
+		if(h[i].denywrite)
+			allow_write_access(h[i].f);
+		fput(h[i].f);
+	}
+	kfree(h);
+}
+
+int
+task_maps_ip(struct task_struct *p, struct inode *ip)
+{
+	register unsigned int i;
+	register int n;
+	int ret = 0;
+	struct held_files *h;
+
+	task_lock(p);
+	if((n = p->mosix.held_allocated))
+	for(h = p->mosix.held_files , i = 0 ; i < n ; i++)
+	if(h[i].f && (h[i].f)->f_dentry->d_inode == ip)
+	{
+		ret = 1;
+		break;
+	}
+	task_unlock(p);
+	return(ret);
+}
+
diff -Naur --exclude=CVS --exclude=configs linux/hpc/service.c linux-openmosix/hpc/service.c
--- linux/hpc/service.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/hpc/service.c	2004-02-05 02:48:27.000000000 +0100
@@ -0,0 +1,463 @@
+/* All changes since Feb 12, 2002 copyright by Moshe Bar
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ *
+ * Author(s): Moshe Bar, Amnon Shiloh.
+ */
+
+
+#include <linux/sched.h>
+#include <linux/hpcctl.h>
+#include <net/sock.h>
+#include <hpc/defs.h>
+#include <hpc/routines.h>
+#include <hpc/debug.h>
+#include <hpc/protocol.h>
+#include <linux/hpc.h>
+#include <asm/uaccess.h>
+#include <asm/mmu_context.h>
+#include <linux/smp_lock.h>
+#include <linux/swap.h>
+#include <linux/stddef.h>
+#include <linux/mm.h>
+#include <linux/delay.h>
+#include <asm/pgtable.h>
+
+/* all sorts of operating-system dependent mob */
+
+void
+common_daemon_setup(char *name, int highpri)
+{
+	register struct task_struct *p = current;
+	struct fs_struct *fs;
+	struct files_struct *fl;
+
+	strcpy(p->comm, name);
+	exit_mm(p);
+	exit_files(p);
+	fl = init_task.files;
+	p->files = fl;
+	atomic_inc(&fl->count);
+	exit_fs(p);
+	fs = init_task.fs;
+	p->fs = fs;
+	atomic_inc(&fs->count);
+#ifdef CONFIG_MOSIX_DFSA
+	atomic_inc(&fs->users);
+#endif /* CONFIG_MOSIX_DFSA */
+
+	p->pgrp = 1;
+	p->session = 1;
+	p->tty = NULL;
+	reparent_to_init();
+	p->it_real_incr = 0;
+	p->it_prof_incr = 0;
+	p->it_virt_incr = 0;
+	p->it_real_value = 0;
+	p->it_prof_value = 0;
+	p->it_virt_value = 0;
+	if(p->uid)
+	{
+		free_uid(p->user);
+		p->uid = 0;
+		alloc_uid(0);
+	}
+	p->euid = 0;
+	p->suid = 0;
+	p->gid = 0;
+	p->ngroups = 0;
+	spin_lock_irq(&p->sigmask_lock);
+	sigemptyset(&p->blocked);
+	recalc_sigpending(p);
+	spin_unlock_irq(&p->sigmask_lock);
+	memcpy(p->rlim, init_task.rlim, sizeof(p->rlim));
+	task_lock(p);
+	if(highpri)
+	{
+		p->policy = SCHED_FIFO;
+		p->mosix.stay |= DSTAY_FOR_RT;
+		p->rt_priority = 0;
+	}
+	else
+	{
+		p->policy = SCHED_OTHER;
+		p->mosix.stay &= ~DSTAY_FOR_RT;
+		p->nice = DEF_NICE;
+	}
+	p->mosix.stay |= DSTAY_SYSTEM;
+	task_unlock(p);
+}
+
+char *
+desc_mostask(struct mosix_task *m)
+{
+	register struct task_struct *p = m ? MOSIX_TO_TASK(m) : current;
+	/* paranoid: save space for each SMP + interrupts */
+	static char descbuf[NR_CPUS+2][14+sizeof(p->comm)];
+	static int ind;
+	static spinlock_t desc_lock = SPIN_LOCK_UNLOCKED;
+	int i;
+
+	spin_lock_irq(&desc_lock);
+	i = ind;
+	ind = (i + 1) % (NR_CPUS+2);
+	spin_unlock_irq(&desc_lock);
+
+	sprintf(descbuf[i], "%d(%s)", p->pid, p->comm);
+	return(descbuf[i]);
+}
+
+asmlinkage void ret_from_kickstart(void) __asm__("ret_from_kickstart");
+
+#define loaddebug(tsk,register) \
+		__asm__("movl %0,%%db" #register  \
+			: /* no output */ \
+			:"r" (tsk->thread.debugreg[register]))
+
+void
+kickstart(void)
+{
+	register struct task_struct *p = current;
+	struct pt_regs *regs, *curegs = mos_to_regs(&p->mosix);
+	/* load segment registers
+	   FIXME: do this only if remote modified LDT */
+	loadsegment(gs, p->mosix.altgs);
+	loadsegment(fs, p->mosix.altgs);
+	set_fs(USER_DS);
+	regs = ((struct pt_regs *) (2*PAGE_SIZE + (unsigned long)p)) - 1;
+	if(regs != curegs)
+	{
+		task_lock(current);
+		*regs = *(curegs);
+		p->mosix.altregs = (uint32_t *)regs;
+		task_unlock(current);
+	}
+	/* the contents of our registers may at this stage still be held
+	 * by our DEPUTY, hence our registers contain junk.
+	 * (which is OK - we are not going to user-mode yet)
+	 * the silly thing about it is that we may get to "ret_from_intr"
+	 * via "do_bottom_half", which might then believe we had a kernel-mode
+	 * interrupt and avoid returning via ret_with_reschedule...
+	 * the remedy is:
+	 */
+	regs->xcs |= 3;
+
+	if(current->thread.debugreg[7])
+	{
+		loaddebug(current,0);
+		loaddebug(current,1);
+		loaddebug(current,2);
+		loaddebug(current,3);
+		loaddebug(current,6);
+		loaddebug(current,7);
+	}
+	release_kernel_lock(current, smp_processor_id());
+	current->lock_depth = -1;
+	/*current->mosix.lock_depth = -1;*/
+	asm("movl %0,%%esp ; jmp ret_from_kickstart" : : "r" (regs));
+	/*NOTREACHED*/
+}
+
+/*
+ * a page on the swap-cache is dirty: even if it happens to be clean relative
+ * to the swap-page, it is NOT clean relative to the original file.
+ */
+static inline int
+pte_really_dirty(pte_t entry)
+{
+	struct page *page;
+
+	if(pte_dirty(entry))
+		return(1);	/* the simple case */
+	page = pte_page(entry);
+	if(!VALID_PAGE(page))
+	{
+		return(1);
+	}
+	return(PageDirty(page) || PageSwapCache(page));
+}
+
+#define	RUN_OVER_MAGIC	126094
+
+static int run_over_maxchunk;
+
+int
+run_over_dirty_pages(int (*func)(unsigned long, int), int count_in_file)
+{
+	struct task_struct *p = current;
+	struct mm_struct *mm = p->mm;
+	struct vm_area_struct *vma;
+	int count = 0;
+	int isfile;
+	unsigned long start, addr, pgd_end, pmd_end, pte_end;
+	pgd_t *pgdir;
+	pmd_t *pmdir;
+	pte_t *pte;
+	int err;
+	int let_go;
+
+	if(!run_over_maxchunk)
+	{
+		/* this routine can take very long for huge processes:
+		 * we must allow other processes to take over at least
+		 * about every millisecond.
+		 */
+		run_over_maxchunk = loops_per_jiffy / RUN_OVER_MAGIC;
+		if(!run_over_maxchunk)	/* slow processors */
+			run_over_maxchunk = 1;
+	}
+
+	addr = 0;
+	loop:
+	let_go = run_over_maxchunk;
+	for(vma = mm->mmap ; vma != NULL ; vma = vma->vm_next)
+	if(addr < vma->vm_end)
+	{
+	    start = vma->vm_start;
+	    if(start < addr)
+		start = addr;
+	    pgdir = pgd_offset(mm, start);
+	    isfile = (vma->vm_file != NULL);
+	    for(addr = start ; addr < vma->vm_end ; addr = pgd_end , pgdir++)
+	    {
+		if(let_go-- == 0)
+		{
+			p->policy |= SCHED_YIELD;
+			schedule();
+			goto loop;
+		}
+		pgd_end = (addr + PGDIR_SIZE) & PGDIR_MASK;
+		if(pgd_end > vma->vm_end)
+			pgd_end = vma->vm_end;
+		if(pgd_none(*pgdir) || pgd_bad(*pgdir))
+			continue;
+		spin_lock(&mm->page_table_lock);
+		pmdir = pmd_offset(pgdir, addr);
+		for(; addr < pgd_end ; addr = pmd_end , pmdir++)
+		{
+		    pmd_end = (addr + PMD_SIZE) & PMD_MASK;
+		    if(pmd_end > pgd_end)
+			    pmd_end = pgd_end;
+		    if(pmd_none(*pmdir) || pmd_bad(*pmdir))
+			    continue;
+		    pte = pte_offset(pmdir, addr);
+		    for(; addr < pmd_end ; addr = pte_end , pte++)
+		    {
+			pte_end = addr + PAGE_SIZE;
+			if(pte_end > pmd_end)
+				pte_end = pmd_end;
+			if(pte_present(*pte) ?
+				(isfile && !pte_really_dirty(*pte)) :
+				pte_none(*pte))
+			{
+				if(isfile && count_in_file)
+					count++;
+				continue;
+			}
+			if(!count_in_file)
+				count++;
+			if(func)
+			{
+				spin_unlock(&mm->page_table_lock);
+				if((err = (*func)(addr, PAGE_SIZE)))
+					return(err);
+				spin_lock(&mm->page_table_lock);
+			}
+		    }
+		}
+		spin_unlock(&mm->page_table_lock);
+	    }
+	}
+	return(count);
+}
+
+#if 0
+/* needed once-only to calibrate the "run_over_maxchunk" calculation */
+/* not bothering using locks here, since we are only called from the debugger */
+int
+calibrate_run_over(void)
+{
+	int sv = run_over_maxchunk;
+	struct mm_struct *mm = current->mm;
+	unsigned int chunks = 0;
+	register struct vm_area_struct *vma;
+	unsigned long addr, pgd_end;
+	__typeof__ (jiffies) before;
+	int milli, magic;
+	int i;
+
+	if(!mm)
+	{
+		printk("No MM\n");
+		return(0);
+	}
+
+	for(vma = mm->mmap ; vma != NULL ; vma = vma->vm_next)
+	for(addr = vma->vm_start ; addr < vma->vm_end ; addr = pgd_end)
+	{
+		chunks++;
+		pgd_end = (addr + PGDIR_SIZE) & PGDIR_MASK;
+		if(pgd_end > vma->vm_end)
+			pgd_end = vma->vm_end;
+	}
+	printk("%d chunks: starting 1000 times...", chunks);
+	run_over_maxchunk = 0x7fffffff;	/* unlimit */
+	sti();
+	before = jiffies;
+	for(i = 0 ; i < 1000 ; i++)
+		run_over_dirty_pages(NULL, 0);
+	milli = (jiffies - before) * 1000 / HZ;
+	printk("%d miliseconds, ", milli);
+	run_over_maxchunk = sv;
+	if(milli < 100)
+	{
+		printk("That was too quick -- try a larger process!\n");
+		return((int)milli);
+	}
+	magic = loops_per_jiffy / (chunks * 1000 / milli);
+	printk("RUN_OVER_MAGIC=%d\n", magic);
+	return(magic);
+}
+#endif /* MOSIX_ONCE_ONLY */
+
+/* provide accurate time in microseconds, even when jiffies wraps around */
+now_t
+time_now(void)
+{
+	static int64_t cycles;
+	static typeof(jiffies) lastj;
+	now_t now;
+	typeof(jiffies) prev;
+	static spinlock_t time_lock = SPIN_LOCK_UNLOCKED;
+
+	if(jiffies == 0 && cycles == 0)
+		return(1);
+	spin_lock_irq(&time_lock);
+	prev = lastj;
+	lastj = jiffies;
+	if(lastj < prev)
+		cycles += 0x100000000LL * MILLION / HZ;
+	now = ticks_to_ms(lastj) + cycles;
+	spin_unlock_irq(&time_lock);
+	return(now);
+}
+
+void
+adjust_task_mosix_context(struct task_struct **tp)
+{
+	struct task_struct *t = *tp;
+
+	if(t->mosix.dflags & DINSCHED)
+		*tp = MOSIX_CONTEXT(t);
+}
+
+int
+obtain_mm(void)
+{
+	struct mm_struct *mm, *active_mm;
+	struct task_struct *p = current;
+	int err;
+
+	if(p->mm)
+		panic("obtain_mm: had already");
+	if(!(mm = mm_alloc()))
+		return(-ENOMEM);
+	if((err = init_new_context(p, mm)))
+	{
+		task_unlock(p);
+		mmdrop(mm);
+		return(err);
+	}
+	spin_lock(&mmlist_lock);
+	list_add(&mm->mmlist, &init_mm.mmlist);
+	mmlist_nr++;
+	spin_unlock(&mmlist_lock);
+	task_lock(p);
+	active_mm = p->active_mm;
+	p->mm = mm;
+	p->active_mm = mm;
+	task_unlock(p);
+	activate_mm(active_mm, mm);
+	mmdrop(active_mm);
+	return(0);
+}
+
+DECLARE_WAIT_QUEUE_HEAD(wait_for_capsync);
+
+void
+sync_caps(void)
+{
+	struct task_struct *p = current;
+	kernel_cap_t prev;
+
+	if(process_told(p, DREQ_CAPCNG))
+	{
+		write_lock_irq(&tasklist_lock);
+		prev = p->mosix.remote_caps;
+		p->mosix.remote_caps = p->cap_effective;
+		process_ack(p, DREQ_CAPCNG);
+		write_unlock_irq(&tasklist_lock);
+		wake_up(&wait_for_capsync);
+		if((p->mosix.dflags & DDEPUTY) &&
+			((prev ^ p->mosix.remote_caps) & REMOTE_CAPS))
+			deputy_request(DEP_CAPS, &p->mosix.remote_caps,
+				sizeof(p->mosix.remote_caps), NULL, 0, 0,
+				NULL, 0);
+	}
+}
+
+int
+mosix_sync_caps(kernel_cap_t effective)
+{
+	unsigned int any = 0;
+	struct task_struct *p;
+	DECLARE_WAITQUEUE(wait, current);
+
+	write_lock_irq(&tasklist_lock);
+	for_each_task(p)
+	if((p->mosix.dflags & (DDEPUTY|DFINISHED)) == DDEPUTY &&
+		p->cap_effective == effective &&
+		((p->mosix.remote_caps ^ effective) & REMOTE_CAPS))
+	{
+		tell_process(p, DREQ_CAPCNG);
+		if(p != current)
+		{
+			any = 1;
+			wake_up_mosix(p);
+		}
+	}
+	write_unlock_irq(&tasklist_lock);
+	sync_caps();	/* affecting ourselves is the most common case */
+	if(!any)
+		return(0);
+	add_wait_queue(&wait_for_capsync, &wait);
+	loop:
+	set_current_state(TASK_INTERRUPTIBLE);
+	any = 0;
+	read_lock(&tasklist_lock);
+	for_each_task(p)
+	if((p->mosix.dflags & (DDEPUTY|DFINISHED)) == DDEPUTY &&
+		p->cap_effective == effective &&
+		(process_told(p, DREQ_CAPCNG)) &&
+		((p->mosix.remote_caps ^ effective) & REMOTE_CAPS))
+	{
+		any = 1;
+		break;
+	}
+	read_unlock(&tasklist_lock);
+	if(any)
+	{
+		schedule();
+		set_current_state(TASK_RUNNING);
+		if(signal_pending(current))
+		{
+			remove_wait_queue(&wait_for_capsync, &wait);
+			return(-EINTR);
+		}
+		goto loop;
+	}
+	remove_wait_queue(&wait_for_capsync, &wait);
+	return(0);
+}
